//
//  Equip.h
//  FutbolStats
//
//  Created by Jaume Ramon Alejandro on 29/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Accio.h"
#import "Jugador.h"

@interface Equip : NSObject {
	NSString *nomEquip;
	NSMutableArray *jugadors;
	NSMutableArray *corners;
	NSMutableArray *gols;
	NSMutableArray *jugades;
	NSMutableArray *faltes;
	NSMutableArray *targetes;
	NSMutableArray *outsides;
	NSMutableArray *notes;
	NSMutableArray *canvis;

}
@property (nonatomic,retain) NSString *nomEquip;
@property (nonatomic,retain) NSMutableArray *jugadors;
@property (nonatomic,retain) NSMutableArray *corners;
@property (nonatomic,retain) NSMutableArray *gols;
@property (nonatomic,retain) NSMutableArray *jugades;
@property (nonatomic,retain) NSMutableArray *faltes;
@property (nonatomic,retain) NSMutableArray *targetes;
@property (nonatomic,retain) NSMutableArray *outsides;
@property (nonatomic,retain) NSMutableArray *notes;
@property (nonatomic,retain) NSMutableArray *canvis;

+(Equip *)crearEquip:(NSString *)nom;
+(void)setNomEquip:(NSString *)nom;
-(void)crearJugadors;
+(NSString *)nomEquip;
+(NSMutableArray *)jugadors;
+(NSMutableArray *)corners;


-(void)ainitAccions;
-(void)actualitzaCorner;
-(NSUInteger)totalCorners;

+(NSMutableArray *)gols;
-(void)actualitzaGol:(Jugador *)jugador origen:(NSString *)origen superficie:(NSString *)superficie assitent:(Jugador *)assistent;
-(NSUInteger)totalGols;

+(NSMutableArray *)jugades;
-(void)actualitzaJugada:(Jugador *)jugador origen:(NSString *)origen superficie:(NSString *)superficie assitent:(Jugador *)assistent;
-(NSUInteger)totalJugades;
-(NSUInteger)totalJugadesAPorta;

+(NSMutableArray *)faltes;
-(void)actualitzaFalta:(Jugador *)infractor assitent:(Jugador *)rebedor;
-(NSUInteger)totalFaltes;

+(NSMutableArray *)canvis;
-(void)actualitzaCanvi:(Jugador *)surt jentra:(Jugador *)entra;
-(NSUInteger)totalCanvis;


+(NSMutableArray *)targetes;
-(void)actualitzaTargeta:(Jugador *)infractor color:(NSString *)colorAmonestacio motiu:(NSString *)motiuAmonestacio;
-(NSUInteger)totalAmonestacions;
-(NSUInteger)totalExpulsions;


+(NSMutableArray *)outsides;
-(void)actualitzaForaDeJoc:(Jugador *)infractor;
-(NSUInteger)totalForaDeJocs;

+(NSMutableArray *)notes;
-(void)actualitzaNota:(Jugador *)jugadorComentat nota:(NSString *)notaIntroduida;
-(NSUInteger)totalNotes;

-(void)introduirJugador:(NSString *)nom dorsal:(NSUInteger *)dorsal estat:(NSUInteger *)estat;

@end
