//
//  Equip.m
//  FutbolStats
//
//  Created by Jaume Ramon Alejandro on 29/04/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "Equip.h"
#import "Jugador.h"
#import "Accio.h"
#import "Corner.h"
#import "Gol.h"
#import "Falta.h"
#import "Targeta.h"
#import "ForaDeJoc.h"
#import "Nota.h"
#import "Canvi.h"

@implementation Equip

@synthesize nomEquip;
@synthesize jugadors;
@synthesize jugades;
@synthesize corners;
@synthesize faltes;
@synthesize targetes;
@synthesize outsides;
@synthesize notes;
@synthesize gols;
@synthesize canvis;

-(void)introduirJugador:(NSString *)nom dorsal:(NSUInteger)dorsal estat:(NSUInteger)estat{

	Jugador* j =[Jugador alloc];
	[j init];
	[j setNom:nom];
	[j setDorsal:dorsal];
	[j setEstat:estat];
	[jugadors addObject:j];	
	[j release];

}


-(id) init{

	if ( self = [super init]){
		[self setNomEquip:@"fdsuio"];
		[self crearJugadors];
		
	}
	[self ainitAccions];

	return self;
	
}


-(void)ainitAccions{
	corners=[[NSMutableArray alloc] initWithObjects:nil];
	gols=[[NSMutableArray alloc] initWithObjects:nil];
	faltes=[[NSMutableArray alloc] initWithObjects:nil];
	jugades=[[NSMutableArray alloc] initWithObjects:nil];
	targetes=[[NSMutableArray alloc] initWithObjects:nil];
	outsides=[[NSMutableArray alloc] initWithObjects:nil];
	notes=[[NSMutableArray alloc] initWithObjects:nil];
	canvis=[[NSMutableArray alloc] initWithObjects:nil];

}

+(void)setNomEquip:(NSString *)nom{	
	[nomEquip autorelease];
	nomEquip = [nom retain];
}

+(NSString*)nomEquip{	
	return nomEquip;	
}

+(NSMutableArray *)corners{	
	return corners;
}

-(void)crearJugadors{
	//Cream els 18 jugadors que poden estar convocats
	
	jugadors =[[NSMutableArray alloc] init];
	
	for (int y = 1; y < 12; y++) {
		NSString *nJugador= [[NSString alloc] initWithFormat:@"Jugador%i",y];
		[self introduirJugador:nJugador dorsal:y estat:0];
		[nJugador release];
	}
	
	//Cream els suplents
	
	for (int y = 12; y < 19; y++) {
		NSString *nJugador= [[NSString alloc] initWithFormat:@"Jugador%i",y];
		[self introduirJugador:nJugador dorsal:y estat:1];
		[nJugador release];
	}
	return self;
}

-(void)actualitzaCorner{
	
	Corner* c=[[Corner alloc] init];
	NSTimeInterval tt = [[NSDate date] timeIntervalSince1970];
	[c setTemps:tt];

	[corners addObject:c];

}

-(NSUInteger)totalCorners{
	return [corners count];
}


+(NSMutableArray *)gols{
	return gols;
}

-(void)actualitzaGol:(Jugador *)jugador origen:(NSString *)origen superficie:(NSString *)superficie assitent:(Jugador *)assistent{
	Gol *g =[[Gol alloc] init];
	[g setOrigen:origen];
	[g setAssistencia:assistent];
	[g setRematador:jugador];
	[g setSuperficie:superficie];
	[gols addObject:g];

	NSTimeInterval tt = [[NSDate date] timeIntervalSince1970];
	[g setTemps:tt];
	[g release];
	
	
	
	
}

-(NSUInteger)totalGols{
	return [gols count]; 
}


+(NSMutableArray *)jugades{
	return jugades;
}

-(void)actualitzaJugada:(Jugador *)jugador origen:(NSString *)origen superficie:(NSString *)superficie assitent:(Jugador *)assistent acabament:(NSString *)acabament{
	Gol *g =[[Gol alloc] init];
	[g setOrigen:origen];
	[g setAssistencia:assistent];
	[g setRematador:jugador];
	[g setSuperficie:superficie];
	[g setAcabament:acabament];
	NSTimeInterval tt = [[NSDate date] timeIntervalSince1970];
	[g setTemps:tt];
	[jugades addObject:g];

	[g release];
}

-(NSUInteger)totalJugades{
	return [jugades count]; 
}

-(NSUInteger)totalJugadesAPorta{
	int i;
	int total =0;
	for (i=0;i<[jugades count];i++){
		if ([[jugades objectAtIndex:i] acabament]==0 || [[jugades objectAtIndex:i] acabament]==1){
			total++;
		}
		
	}
		 
		 return total;
		
}


+(NSMutableArray *)faltes{
	return faltes;
}

-(void)actualitzaFalta:(Jugador *)infractor assitent:(Jugador *)rebedor{

	Falta *f=[[Falta alloc] init];
	[f setRebedor:rebedor];
	[f setInfractor:infractor];
	NSTimeInterval tt = [[NSDate date] timeIntervalSince1970];
	[f setTemps:tt];
	[faltes addObject:f];
}
-(NSUInteger)totalFaltes{
	return [faltes count];
}

+(NSMutableArray *)canvis{
	return canvis;
}
	
-(void)actualitzaCanvi:(Jugador *)surt jentra:(Jugador *)entra{
	Canvi *c=[[Canvi alloc] init];
	[c setJugadorSurt:surt];
	[c setJugadorEntra:entra];
	NSTimeInterval tt = [[NSDate date] timeIntervalSince1970];
	[c setTemps:tt];
	[canvis addObject:c];
	
}
-(NSUInteger)totalCanvis{
	return [canvis count];
}



+(NSMutableArray *)targetes{
	return targetes;
}

-(void)actualitzaTargeta:(Jugador *)infractor color:(NSString *)colorAmonestacio motiu:(NSString *)motiuAmonestacio{

	Targeta *t=[[Targeta alloc] init];
	[t setJugador:infractor];
	[t setColor:colorAmonestacio];
	[t setMotiu:motiuAmonestacio];
	
	NSTimeInterval tt = [[NSDate date] timeIntervalSince1970];

	[t setTemps:tt];
	
	
	//mirar que si li treuen vermella sigui expulsat
	
	int i;
	NSString *s= [[NSString alloc] initWithString:@"Groga"];
	


	//miram si el jugador és expulsat
	if ([t color]==@"Vermella"){
		[[t jugador] setEstat:2];
	}
	
	else{
	
		NSLog(@"%i",[targetes count]);
	for (i=0;i<[targetes count];i++){
	

		//si n'hi havien tret una l'expulsam
		NSLog(@"for");
		
		if ([[[targetes objectAtIndex:i] jugador] isEqual:infractor] && [[targetes objectAtIndex:i] color]==s){
			NSLog(@"entra");

			Targeta *t2=[[Targeta alloc] init];
			[t2 setColor:@"Vermella"];
			[t2 setMotiu:@"Doble amonestació"];
			[t2 setJugador:infractor];
			[t2 setTemps:tt];
			[targetes addObject:t2];
			//[targetes addObject:t];
			
			[[[targetes objectAtIndex:i] jugador] setEstat:2];

		}
	}
	}

	[targetes addObject:t];

}

-(NSUInteger)totalAmonestacions{
	int i;
	int total=0;
	NSString *s= [[NSString alloc] initWithString:@"Groga"];

	

	for (i=0;i<[targetes count];i++){

		if ([[targetes objectAtIndex:i] color]==s){
			total++;

		}
		

	}
			return total;
	//return [targetes count];
}

-(NSUInteger)totalExpulsions{
	int i;
	int total=0;
	NSString *s= [[NSString alloc] initWithString:@"Vermella"];

	for (i=0;i<[targetes count];i++){
		
		if ([[targetes objectAtIndex:i] color]==s){
			total++;
		}
	}
	
	return total;
}


+(NSMutableArray *)outsides{
	return outsides;
}
	
-(void)actualitzaForaDeJoc:(Jugador *)infractor{
	
	ForaDeJoc *f=[[ForaDeJoc alloc] init];
	[f setJugador:infractor];
	NSTimeInterval tt = [[NSDate date] timeIntervalSince1970];
	[f setTemps:tt];
	[outsides addObject:f];
}
-(NSUInteger)totalForaDeJocs{

	return [outsides count];

}

+(NSMutableArray *)notes{
	return notes;
}
-(void)actualitzaNota:(Jugador *)jugadorComentat nota:(NSString *)notaIntroduida{
	Nota *n=[[Nota alloc] init];
	[n setAnotacio:notaIntroduida];
	NSLog(notaIntroduida);
	[n setJugador:jugadorComentat];
	NSLog(@"aqui baix");
	NSLog([n anotacio]);
	NSLog(@"aqui dalt");

	[notes addObject:n];
	
	
}

-(NSUInteger)totalNotes{
	return [notes count];
}


@end
